//***************************************************************************
//
//  ̧......: main.c
//  ......: ATMEL Norway, ATMEL Finland
//  ړIΏ..: ATmega169
//  ߲....: IAR EWAAVR 4.10B
//  ......: AVR441̧ݐp呕u
//  ......: 1.1
//
//  N   -   - 											- 
//  20030116 - 1.0 - 쐬(AVR Butterflyp)						- KS
//  20050209 - 1.1 - ̧ݐ呕upɉ						- KMe
//
//***************************************************************************

#include <inavr.h>
#include <ioavr.h>

#include "main.h"
#include "LCD_functions.h"
#include "LCD_driver.h"
#include "button.h"
#include "timer0.h"
#include "BCD.h"
#include "USI_TWI_Master.h"
#include "Fan_functions.h"
#include "menu.h"

#define pLCDREG_test (*(char *)(0xEC))

/* S̕ϐ` */

extern __flash unsigned int LCD_character_table[];				// ˾Ēlϊ\
char gAutoPressJoystick = FALSE;								// ͌JԂ׸(FALSE=~,AUTO=Ԋu,TRUE=ON)
char gPlaying = FALSE;											// ȍĐON/OFF׸(Đ̏ȓd͈ڍsh~Ɏgp:sound.c)
char gUART = FALSE;												// USARTgp׸(gp̏ȓd͈ڍsh~Ɏgp:vcard.c)
char gUSI = FALSE;												// USIgp׸(gp̏ȓd͈ڍsh~Ɏgp:USI_TWI_Master.c)
unsigned char state;											// menu.hŒ`ꂽ݂̏Ԕԍ

//*****************************************************************************
//*
//* ֐	: main
//* 	: Ȃ
//* Ԃl	: Ȃ
//* ړI	: JԂ
//*
//*****************************************************************************
__C_task void main(void)
{
  unsigned char nextstate;						// Ԕԍ
  static char __flash *statetext;				// Ήƭ߲
  char (*pStateFunc)(char);						// s߲
  char input;									// ޮèԔԍ
  char i;										// Ɨp
  char buttons;									// ޮè Ԓl
  char last_buttons;							// O̼ޮè Ԓl

  /* Ԋ֌Wl */
  state = nextstate = ST_MAIN;					// Ԕԍ
  statetext = MT_MAIN;							// ƭ߲
  pStateFunc = NULL;							// s߲
  /* ۸ъ֌W */
  Initialization();								// e
  __enable_interrupt();							// S̊荞݋
  /* 又 */
  for (;;)
  {
	/* ƭs */
	if (statetext)								/* (ƭL) */
	{
	  LCD_puts_f(statetext, 1);					// ΉƭLCDޯ̧]
	  LCD_Colon(0);								// LCD(:)\OFFݒ
	  statetext = NULL;							// ƭȂݒ
	}

	input = getkey();							// ޮèԔԍ擾
	if (pStateFunc)								// sLŁA
	{
	  nextstate = pStateFunc(input);			// ΉssԔԍ擾
	}
	else if (input != KEY_NULL)					// ޮèꂩ̽ONŁA
	{
	  nextstate = StateMachine(state, input);	// ԑJڌԔԍ擾
	}
	if (nextstate != state)						/* (ԔԍvύX) */
	{
	  state = nextstate;						// ԔԍXV
	  for (i=0; menu_state[i].state; i++)		/* (( ƭ/sʒu擾)) */
	  {
		if (menu_state[i].state == state)		// ΉԔԍvŁA
		{
		  statetext =  menu_state[i].pText;		// Ήƭ擪ʒu擾
		  pStateFunc = menu_state[i].pFunc;		// Ήs擪ʒu擾
		  break;								// I
		}
	  }
	}

	/* ޮè pON̎JԂ */
	buttons = (~PINB) & PINB_MASK;				// ߰B_l擾
	buttons |= (~PINE) & PINE_MASK;				// ߰E_l܂ݑSl擾
	if( buttons != last_buttons )				/* ԕω */
	{
	  last_buttons = buttons;					// 񽨯lۑ
	  gAutoPressJoystick = FALSE;				// ͌JԂ׸މ(~ݒ)
	}
	else if( buttons )							/* Ԗωꂩ̽ON */
	{
	  if( gAutoPressJoystick == TRUE)			// JԂԊuo߂ŁA
	  {
		PinChangeInterrupt();					// ԍĎ擾
		gAutoPressJoystick = AUTO;				// JԂԊuvݒ
	  }
	  else										// JԂ~܂͊ԊuvŁA
		gAutoPressJoystick = AUTO;				// JԂԊuvݒ
	}
  }
}

//*****************************************************************************
//*
//* ֐	: StateMachine
//* 	: state : Ԕԍ, stimuli : ޮèԔԍ
//* Ԃl	: nextstate : Ԕԍ
//* ړI	: ԑJڌԔԍ擾
//*
//*****************************************************************************
unsigned char StateMachine(char state, unsigned char stimuli)
{
  unsigned char nextstate = state;					// Ԕԍ(:Ԕԍ)
  unsigned char i;									// Ɨp

  for (i=0; menu_nextstate[i].state; i++)			/* ̏ԑJڌ */
  {
	if (menu_nextstate[i].state == state && menu_nextstate[i].input == stimuli)
	{												// ԔԍONԍvŁA
	  nextstate = menu_nextstate[i].nextstate;		// Ԕԍ擾
	  break;										// I
	}
  }
  return nextstate;									// ԔԍƋɕA
}

//*****************************************************************************
//*
//* ֐	: Initialization
//* 	: Ȃ
//* Ԃl	: Ȃ
//* ړI	: e
//*
//*****************************************************************************
void Initialization(void)
{
  OSCCAL_calibration(); 				// OSCCALZ
  CLKPR = (1<<CLKPCE);					// OulύXޯĐݒ
  CLKPR = (1<<CLKPS1) | (1<<CLKPS0);	// 8Ou ۯݒ(8MHz/8=1MHz)
  ACSR = (1<<ACD);						// ۸ޔr퓮֎~
  DIDR1 = (7<<ADC0D);					// ADC2`0޼ٓ͋֎~	[Bug:=DIDR0]
  PORTB = (15<<PORTB0);					// SPI֌Wޯ ٱߐݒ
  PORTE = (15<<PORTE4);					// ֌Wޯ ٱߐݒ
  sbi(DDRB, 5);							// OC1Ao͐ݒ
  sbi(PORTB, 5);						// OC1A=H
  Button_Init();						// ޮè ֌W
  Timer0_Init();						// /0(ȍĐ̑Ŏgp)
  LCD_Init();							// LCD֌W
  USI_TWI_Master_Initialize();			// USITWI呕uƂď
}

//*****************************************************************************
//*
//* ֐	: Delay
//* 	: unsigned int millisec (1msPʑҋ@)
//* Ԃl	: Ȃ
//* ړI	: 1msPʑҋ@
//*
//*****************************************************************************
void Delay(unsigned int millisec)
{
  int i;						// Ɨp

  while (millisec--)			/* wmsҋ@ */
	for (i=0; i<125; i++);
}

//*****************************************************************************
//*
//* ֐	: OSCCAL_calibration
//* 	: Ȃ
//* Ԃl	: Ȃ
//* ړI	: O32.768kHzؽقOSCCALZ
//*
//*****************************************************************************
void OSCCAL_calibration(void)
{
  unsigned char calibrate = FALSE;			// Z׸
  int temp;									// /1vl
  unsigned char tempL;						// /1vl޲Ēl

  CLKPR = (1<<CLKPCE);						// OulύXޯĐݒ
  CLKPR = (1<<CLKPS1) | (1<<CLKPS0);		// 8Ou ۯݒ(8MHz/8=1MHz)
  TIMSK2 = 0;								// /2S荞݋֎~
  ASSR = (1<<AS2);							// /2񓯊ݒ
  OCR2A = 200;								// /2rl
  TIMSK0 = 0;								// /1S荞݋֎~
  TCCR1B = (1<<CS10);						// /1OuȂN
  TCCR2A = (1<<CS20);						// /2OuȂN
  while((ASSR & 0x01) | (ASSR & 0x04));		// /2֌Wڼ޽XV܂őҋ@
  Delay(1000);								// O32.768kHzؽٔUҋ@
  while(!calibrate)							/* Z܂ł̌p */
  {
	__disable_interrupt();					// S̊荞݋֎~
	TIFR1 = 0xFF;							// /1S荞ݗv׸މ
	TIFR2 = 0xFF;							// /2S荞ݗv׸މ
	TCNT1H = 0;								// /1vl
	TCNT1L = 0;
	TCNT2 = 0;								// /2vl
	while ( !(TIFR2 && (1<<OCF2A)) );		// 32.768kHz200ۯ(OCR2Av)܂őҋ@
	TCCR1B = 0;								// /1v~
	__enable_interrupt();					// S̊荞݋
	if ( (TIFR1 && (1<<TOV1)) )				// /1ŁA
	{
	  temp = 0xFFFF;						// /1vlƂčőlݒ	[Bug:tempt̂-1ƂĈ]
	}
	else									// /1ȂŁA
	{
	  tempL = TCNT1L;						// /1vlʎ擾
	  temp = TCNT1H;						// /1vlʎ擾
	  temp = (temp << 8);					// 擾ʂ޲Ĉʒuֈړ
	  temp += tempL;						// /1vl擾
	}

	if (temp > 6250)						// /1vlKzŁA
	{
	  OSCCAL--;								// UZl
	}
	else if (temp < 6120)					// /1vlK艺ŁA
	{
	  OSCCAL++;								// UZl
	}
	else									// /1vlK͈͓ŁA
	  calibrate = TRUE;						// Z׸ސݒ
	TCCR1B = (1<<CS10);						// /1Ďn
  }
}

//*****************************************************************************
//*
//* ֐	: TWI_Act_On_Failure_In_Last_Transmission
//* 	: unsigned char TWIerrorMsg (TWIُ필)
//* Ԃl	: unsigned char TWIerrorMsg (TWIُ필)
//* ړI	: 茟o̓܂B茴TWIerrorMsggp܂B
//*
//*****************************************************************************
unsigned char TWI_Act_On_Failure_In_Last_Transmission(unsigned char TWIerrorMsg)
{	// L蓾үނ̈ꗗɂĂͯ ̧قB
  __no_operation();			// 
  return TWIerrorMsg;		// ُ필ƋɕA
}
